package io.gmss.fiscad.implementations.infocad.parametre;

import io.gmss.fiscad.entities.infocad.parametre.TypePersonne;
import io.gmss.fiscad.exceptions.BadRequestException;
import io.gmss.fiscad.exceptions.NotFoundException;
import io.gmss.fiscad.interfaces.infocad.parametre.TypePersonneService;
import io.gmss.fiscad.repositories.infocad.parametre.TypePersonneRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class TypePersonneServiceImpl implements TypePersonneService {

    private final TypePersonneRepository typePersonneRepository;

    public TypePersonneServiceImpl(TypePersonneRepository typePersonneRepository) {
        this.typePersonneRepository = typePersonneRepository;
    }

    @Override
    public TypePersonne createTypePersonne(TypePersonne typePersonne) throws BadRequestException {
        if (typePersonne.getId() != null) {
            throw new BadRequestException("Impossible de créer un nouveau type de personne ayant un id non null.");
        }
        return typePersonneRepository.save(typePersonne);
    }

    @Override
    public TypePersonne updateTypePersonne(Long id, TypePersonne typePersonne) throws NotFoundException {
        if (typePersonne.getId() == null) {
            throw new BadRequestException("Impossible de mettre à jour un nouveau type de personne ayant un id null.");
        }
        if (!typePersonneRepository.existsById(typePersonne.getId())) {
            throw new NotFoundException("Impossible de trouver le type de personne spécifié dans notre base de données.");
        }
        return typePersonneRepository.save(typePersonne);
    }

    @Override
    public void deleteTypePersonne(Long id) throws NotFoundException {
        Optional<TypePersonne> typePersonneOptional = typePersonneRepository.findById(id);
        if (typePersonneOptional.isPresent()) {
            typePersonneRepository.deleteById(typePersonneOptional.get().getId());
        } else {
            throw new NotFoundException("Impossible de trouver le type de personne spécifié dans notre base de données.");
        }
    }

    @Override
    public Page<TypePersonne> getTypePersonneList(Pageable pageable) {
        return typePersonneRepository.findAll(pageable);
    }

    @Override
    public List<TypePersonne> getTypePersonneList() {
        return typePersonneRepository.findAll();
    }

    @Override
    public Optional<TypePersonne> getTypePersonneById(Long id) {
        if (typePersonneRepository.existsById(id)) {
            return typePersonneRepository.findById(id);
        } else {
            throw new NotFoundException("Impossible de trouver le type de personne spécifié dans la base de données.");
        }

    }
}
